#pragma once

#include <Poco/Path.h>


/** Создаёт локальный (в той же точке монтирования) бэкап (снэпшот) директории.
  *
  * В указанной destination-директории создаёт hard link-и на все файлы source-директории
  *  и во всех вложенных директориях, с сохранением (созданием) всех относительных путей;
  *  а также делает chown, снимая разрешение на запись.
  *
  * Это защищает данные от случайного удаления или модификации,
  *  и предназначено для использования как простое средство защиты от человеческой или программной ошибки,
  *  но не от аппаратного сбоя.
  */
void localBackup(Poco::Path source_path, Poco::Path destination_path);
