#pragma once

#include <string>


namespace DB
{

class IAST;

/// Получить имя кластера из AST.
/** Имя кластера - это имя тега в xml-конфигурации.
  * Обычно оно парсится как идентификатор. То есть, оно может содержать подчёркивания, но не может содержать дефисы,
  *  при условии, что идентификатор не находится в обратных кавычках.
  * Но в xml в качестве имени тега более привычно использовать дефисы.
  * Такое имя будет парситься как выражение с оператором минус - совсем не то, что нужно.
  * Поэтому, рассмотрим такой случай отдельно.
  */
std::string getClusterName(const IAST & node);

}
